//_________________________________________________________________________
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
// NOMBRE: GBADDraw.h
// AUTOR: Eloist and Eduardo Pinera Aznarez
// DESCRIPCION: Funciones 2D para Game Boy Advanced.
//
// FECHA INICIO: 16 de Noviembre de 2000.
// ULTIMA ACTUALIZACION: 16 de Noviembre de 2000.
//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//

#ifndef GBADDRAW_HEADER
#define GBADDRAW_HEADER


typedef struct GBARECT
{
	unsigned long	Left;
	unsigned long	Top;
	unsigned long	Right;
	unsigned long	Bottom;
}GBARECT;


//_________________________________________________________________________
//*************************************************************************
//*************************************************************************
//
//
//
//							CONVERT XX BPP to 32 BPP.
//
//
//
//*************************************************************************
//*************************************************************************
//



//
//			      VARIABLES
//____________________________________________




//
//		LINEAS DE PROTOTIPO DE FUNCIONES
//____________________________________________
extern DWORD Convert8to32(BYTE R, BYTE G, BYTE B);
extern DWORD Convert15to32(WORD Color);
extern DWORD Convert16to32(WORD Color);
extern DWORD Convert24to32(DWORD Color);




//_________________________________________________________________________
//*************************************************************************
//*************************************************************************
//
//
//
//							CONVERT 32 BPP to XX BPP.
//
//
//
//*************************************************************************
//*************************************************************************
//


//
//			      VARIABLES
//____________________________________________




//
//		LINEAS DE PROTOTIPO DE FUNCIONES
//____________________________________________
extern VOID Convert32to8(DWORD Color, BYTE *R, BYTE *G, BYTE *B);
extern WORD Convert32to15(DWORD Color);
extern WORD Convert32to16(DWORD Color);
extern DWORD Convert32to24(DWORD Color);



//_________________________________________________________________________
//*************************************************************************
//*************************************************************************
//
//
//
//				VARIABLES Y FUNCIONES GENERICAS DE DIBUJO Y 
//						VOLCADO DE PIXELS Y BUFFERS
//								PARA EL MODO 3
//
//
//
//*************************************************************************
//*************************************************************************
//


//
//			      VARIABLES
//____________________________________________




//
//		LINEAS DE PROTOTIPO DE FUNCIONES
//____________________________________________
extern void M3PutPixelRGB888(unsigned char X, unsigned char Y, unsigned char ColorR, unsigned char ColorG, unsigned char ColorB);
extern void M3PutPixel888(unsigned char X, unsigned char Y, unsigned long DWColor);
extern void M3PutPixelRGB555(unsigned char X, unsigned char Y, unsigned char ColorR, unsigned char ColorG, unsigned char ColorB);
extern void M3PutPixel555(unsigned char X, unsigned char Y, unsigned short Color);

extern void M3Blit15(long X, long Y, unsigned char Width, unsigned char Height, unsigned short *Buffer);

extern void M3ClearScreen(void);

#endif //GBADDRAW_HEADER