//_________________________________________________________________________
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
// NOMBRE: GBAMain.c
// AUTOR: Eduardo Pinera Aznarez
// DESCRIPCION: Entrada del programa.
//
// FECHA INICIO: 3 de Noviembre de 2000.
// ULTIMA ACTUALIZACION: 3 de Noviembre de 2000.
//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//

#include <stdio.h>
#include <stdlib.h>

#include "GBASystem.h"
#include "GBADDraw.h"
#include "GBADInput.h"


extern unsigned char PIC_Present;


void GBAMain(void)
{
	unsigned long	X;
	unsigned long	Y;
	unsigned short	PadState;
	unsigned short *Picture1;

	Picture1 = (unsigned short *) (&PIC_Present);

	// Display modo 3
	REG_DISPCNT		= BG_MODE_3;
	REG_DISPSTAT	= BG3_ENABLE;

	M3ClearScreen();
	ClearPad();

	X = 0;
	Y = 0;
	while(1)
	{
		WaitVerticalRetrace();
		
		ReadPad(&PadState);

		switch(PadState)
		{
			case KEY_LEFT:
				X = X - 1;
				ClearPad();
				M3ClearScreen();
				break;

			case KEY_UP:
				Y = Y - 1;
				ClearPad();
				M3ClearScreen();
				break;

			case KEY_RIGHT:
				X = X + 1;
				ClearPad();
				M3ClearScreen();
				break;

			case KEY_DOWN:
				Y = Y + 1;
				ClearPad();
				M3ClearScreen();
				break;
		};

		M3Blit15(X, Y, 240, 160, Picture1);
	}
}