//_________________________________________________________________________
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
// NOMBRE: GBASystem.c
// AUTOR: Eduardo Pinera Aznarez
// DESCRIPCION: Registros, Variables y funciones genericas de la 
//	Game Boy Advanced.
//
// FECHA INICIO: 3 de Noviembre de 2000.
// ULTIMA ACTUALIZACION: 16 de Noviembre de 2000.
//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//

#include <stdio.h>
#include <stdlib.h>

#include "GBASystem.h"

u32 g_VCount;
//_________________________________________________________________________
//*************************************************************************
//*************************************************************************
//
//
//
//		VARIABLES Y FUNCIONES GENERICAS SOBRE CARACTERISTICAS TECNICAS 
//							DE LA GAME BOY ADVANCE
//
//
//
//*************************************************************************
//*************************************************************************
//



//
//			      VARIABLES
//____________________________________________




//
//		LINEAS DE PROTOTIPO DE FUNCIONES
//____________________________________________
void WaitVerticalRetrace(void);



//
//			      FUNCIONES
//____________________________________________



//________________________________________________________________________
// Name: WaitVerticalRetrace()
// Desc: Espera a que se produzca un retrazo vertical.
//
void WaitVerticalRetrace(void) 
{
	__asm
	{
			mov		r0, #0x04000006

		wait:
			ldrh	r1, [r0]
			cmp		r1, #160
			bne		wait
	}

	//increment the global VBlank counter
	++g_VCount;
}

/* Chiamata al DMA */
void DMA3Call(u32 Src, u32 Dst, u32 Cnt)
{
	REG_DMA3SAD = Src;
	REG_DMA3DAD = Dst;
	REG_DMA3CNT = Cnt;
}